static DH *get_dh512(void)
{
    static unsigned char dhp_512[] = {
        0xDB, 0x64, 0xC4, 0x45, 0xC6, 0x6B, 0x7D, 0x84, 0x54, 0x47,
        0xC6, 0xF1, 0x07, 0xB7, 0xE2, 0xBA, 0x18, 0x2A, 0x5C, 0xCA,
        0x87, 0x4C, 0x4E, 0x47, 0xC4, 0xE1, 0x1B, 0x10, 0x4D, 0x1C,
        0x64, 0x8F, 0x7D, 0x84, 0x0E, 0x81, 0xF0, 0x91, 0xA2, 0x7E,
        0x79, 0x5E, 0x78, 0xAE, 0xD2, 0xF4, 0x8F, 0xDE, 0x52, 0x84,
        0xEE, 0xCE, 0x3C, 0x16, 0x77, 0x6C, 0xA6, 0x56, 0xBD, 0x20,
        0xD7, 0x5C, 0x29, 0xC3
    };
    static unsigned char dhg_512[] = {
        0x05
    };
    DH *dh = DH_new();
    BIGNUM *p, *g;

    if (dh == NULL)
        return NULL;
    p = BN_bin2bn(dhp_512, sizeof(dhp_512), NULL);
    g = BN_bin2bn(dhg_512, sizeof(dhg_512), NULL);
    if (p == NULL || g == NULL
            || !DH_set0_pqg(dh, p, NULL, g)) {
        DH_free(dh);
        BN_free(p);
        BN_free(g);
        return NULL;
    }
    return dh;
}
